<?php
/*
 * Google Meet for LatePoint
 * Copyright (c) 2022-2023 TechXela (https://codecanyon.net/user/tech-xela). All Rights Reserved.
 *
 * LICENSE
 * -------
 * This software is furnished under license(s) and may be used and copied only in accordance with the terms of such
 * license(s) along with the inclusion of the above copyright notice. If you purchased this software through CodeCanyon,
 * please read the full license(s) at: https://codecanyon.net/licenses/standard
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

if ( ! class_exists( 'TechXelaLatePointGoogleMeetSettingsHelper' ) ) {

	final class TechXelaLatePointGoogleMeetSettingsHelper {
		use \TechXela\LatePointAddons\Traits\IsSettingsHelper;

		public const scopedOptionPrefix = 'gmeet';

		public static function getMeetingNameTemplate() {
			return TechXelaLatePointGoogleMeetSettingsHelper::getSetting( '', 'meeting_name_template', '{{service_name}}' );
		}

		public static function externalMeetingSystemSettings() {
			?>
            <div class="sub-section-row">
                <div class="sub-section-label">
                    <h3><?php esc_html_tx_e( 'Meeting Name Template', 'google-meet-latepoint' ); ?></h3>
                </div>
                <div class="sub-section-content">
                    <div class="latepoint-message latepoint-message-subtle"><?php esc_html_tx_e( 'You can use variables in your meeting name template. Just click on the variable with {} brackets and it will automatically copy to your buffer and you can simply paste it where you want to use it. It will be converted into a value for the agent/customer or appointment.', 'google-meet-latepoint' ) ?><?php echo OsUtilHelper::template_variables_link_html(); ?></div>
					<?php echo OsFormHelper::text_field(
						self::settingName( '', 'meeting_name_template' ),
						false,
						self::getMeetingNameTemplate(),
						[ 'theme' => 'bordered' ]
					); ?>
                </div>
            </div>
			<?php
		}
	}

}